import astropy,os,scipy,scipy.interpolate
#import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits
from scipy.optimize import curve_fit

os.system('ls e*.fits > fits.lst')
a=np.linspace(23,2023,81)
b=np.linspace(0,0,81)
xx=np.empty((10000))
yy=np.empty((10000))
x=np.linspace(0,9999,10000)
sky=np.empty((16,64,500))
sky_all=np.empty((500))
sky_ref=np.empty((16,500))

os.system('rm -f fitting_para.dat')
output=open("fitting_para.dat","w")

j=0
for line in open("fits.lst"):
    line=line.strip("\n")
    objectname=fits.getval(line,'IMAGETYP',0)
    if (objectname != 'zero'):# and (objectname != 'flat'):
        object=fits.open(line)
#        print line,np.median(object[1].data)

        for k in range(16):
            data=object[k+1].data
            sky_all[j]=np.median(data)
            for m in range(8):
                for n in range(8):
                    sky[k,m*8+n,j]=np.median(data[m*256:(m+1)*256,n*252:(n+1)*252])

            sky_ref[k,j]=np.median(data[500:1500,500:1500])
            sky1=sky[k,:,j]/sky_ref[k,j]

        j=j+1

        object.close()

num=j-1

#print sky_ref[0,0:num]

def func(x,a,b):
    return a*np.exp(b/x)

for k in range(16):

    print('CCD  ',k+1)
    output.write('CCD  '+str(k+1)+"\n")
#    print num,sky[k,0,0:num],sky[k,0,0:num]/sky_ref[15,0:num]

    for i in range(64):
        m=-1
        for j in range(num):
#            print sky[k,i,j],sky_ref[0,j]
            if (sky[k,i,j]/sky_ref[15,j] <= np.median(sky[k,i,0:num]/sky_ref[15,0:num])+3.*np.std(sky[k,i,0:num]/sky_ref[15,0:num])):
                m=m+1
                xx[m]=sky[k,i,j]
                yy[m]=sky[k,i,j]/sky_ref[15,j]

#        print m,xx[0:m],yy[0:m]
#        popt, pcov = curve_fit(func,sky[k,i,0:num],sky[k,j,0:num]/sky_ref[15,0:num])
        popt, pcov = curve_fit(func,xx[0:m],yy[0:m])
        aa=popt[0]
        bb=popt[1]
#        cc=func(x,aa,bb)
#        print(aa,bb)#,sky[j,106]/sky[id_s,106]
        output.write(str(aa)+"   "+str(bb)+"\n")
#        plt.axis([0.,2000.0,0.85,1.05])
#        plt.plot(sky[j,:],sky[j,:]/sky[id_s,:],'bo')
#        plt.plot(x,cc,'r',lw=3)
#        plt.plot(sky[j,:],sky[j,:]/sky[id_s,:],'o')
#        plt.xlabel('Sky ADU') 
#        plt.ylabel('Sky ADU / Sky ADU (standard)')
#        plt.show()
#        raw_input()
output.close()
